/*
	Introduction of FrogeMap:

	This is the first draft of the code of the FrogeMap program. The point of this
	map is to enter 2 room numbers and give directions from one room number to another.
	The code currently functions as it will output the shortest path between 2 given
	rooms on the first floor of ISB. The data for the second and third floor are work
	in progress and will be done soon. Currently, the map will also output values for
	debugging, and this feature will be deleted in the final draft as it will only
	output directions to the user.

	The final draft will be done in approximately 2-3 weeks.

*/
#include <bits/stdc++.h>
using namespace std; // Define Variables
	const int n = 60, m = 100, l = 1; // size of isb
	int cur, des, dir; //starting and end room number, dir is direction (output)
	int sx, sy, sz, fx, fy, fz, ct; //for search
	int nowstp, vxs, vys, vzs, vxf, vyf, vzf, didx, strct; // for trace
	int sdx[6] = {0, 0, -1, 1, 0, 0};
	int sdy[6] = {-1, 1, 0, 0, 0, 0};
	int sdz[6] = {0, 0, 0, 0, -1, 1};
	int v[100][200][5];
	struct node{
		int x;
		int y;
		int z;
		int step;
	};
	struct coord{
		int x;
		int y;
		int z;
	};
	coord ddpre; // difference of direction of previous set
	coord ddnow; // difference of direction of current set
	queue<node> q; // used for bfs
	vector<coord> path; // the shortest path from start to finish
	stack<int> px;
	stack<int> py;
	stack<int> pz;
	string dirmap[5] = {"_", "left", "right", "up", "down"}; 
	// coodinates of each step in the shortest path
	int isb[65][105][1] = {
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    0,     1,    1,    1,    1,     1,     1,     2,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    1723, 1723, 1723, 0,    1725, 1725, 0,    1727, 1727, 1727, 0,    1720, 1720, 1720, 1720, 1720, 1720, 0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    0,     1,    1,    1,    1,     1,     1,     2,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    2,    1723, 1723, 1723, 0,    1725, 1725, 0,    1727, 1727, 1727, 0,    1720, 1720, 1720, 1720, 1720, 1720, 0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    0,     1,    0,    0,    0,     0,     0,     0,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    0,    17231,2,    2,    1725, 1725, 2,    1727, 1727, 1727, 0,    1720, 1720, 1720, 1720, 1720, 1720, 0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    0,     1,    0,    0,    0,     0,     0,     0,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    1721, 0,    17231,17192,0,    0,    2,    0,    0,    0,    2,    0,    2,    0,    0,    2,    0,    0,    0,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    0,     1,    0,    0,    0,     0,     0,     0,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    0,    0,    0,    0,    1,    1709, 1709, 1709, 1709, 1709, 0,    1,    1,    1,    1,    1,    1,    2,    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 0,    0,     0,    0,    0,     0,    0,     0,    0,     0, 0,    0,    0,    0,    0,    1,     1,    1,    2,    1,     3,     3,     0,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    1,    3,    3,    0,    0,    1,    1709, 1709, 1709, 1709, 1709, 2,    1,    1,    1,    1,    3,    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,   0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 1,    0,     1531, 1531, 1531,  0,    1533,  0,    1537,  0, 1541, 1,    2,    1,    1,    1,     1,    1,    0,    0,     3,     3,     0,     1680, 1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    3,    3,    0,    0,    1,    17093,17091,17091,0,    17072,0,    1,    0,    2,    2,    0,    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,    0,    0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      0, 1,    2,     1531, 1531, 1531,  0,    1533,  0,    1537,  0, 1539, 1,    0,    2,    2,    0,     2,    0,    0,    0,     0,     0,     0,     0,    0,     0,     0,     0,     1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    1717, 0,    0,    0,    0,    1,    17092,17071,17071,0,    17072,0,    1,    0,    17081,1,    1710, 0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,    0, 1843, 0, 1840, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    0,     0,    0,    2,     0,    2,     1535, 2,     0, 0,    1,    0,    1683, 1683, 1683,  1683, 1683, 1683, 2,     1,     1,     1,     1,    1,     1,     1,     2,     1680,  1680,  1680,  1680,  1680, 1680, 1680, 2,    1,    17151,0,    1713, 1713, 0,    1,    17071,17071,17071,0,    17072,0,    1,    0,    17081,2,    2,    0,    17182,2,    1718, 0,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    1845, 3, 1842, 1, 1840, 0, 1839, 1839, 1839, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     1, 0,    1,    0,    1683, 1683, 1683,  1683, 1683, 1683, 0,     0,     0,     0,     0,    0,     0,     0,     0,     0,     0,     1680,  1680,  1680, 1680, 1680, 1680, 1680, 0,    1,    1715, 0,    1713, 1713, 0,    1,    17071,17071,17071,0,    17072,2,    1,    0,    17081,1712, 1714, 0,    17182,0,    1718, 0,    1,    2,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1, 2, 2, 1, 2, 1840, 0, 1839, 1839, 1839, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    0,     0,    0,    2,     0,    0,     0,    0,     0, 0,    2,    0,    1683, 1683, 1683,  1683, 1683, 1683, 0,     0,     0,     0,     0,    0,     0,     0,     0,     0,     0,     1680,  1680,  1680, 1680, 1680, 1680, 1680, 0,    1,    2,    1,    1713, 1713, 0,    1,    0,    0,    0,    0,    0,    0,    1,    0,    17081,1712, 1714, 0,    0,    0,    1718, 2,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1, 0, 0, 2, 1, 2, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1,     2,    1,    1,     0,    0,     0,    0,     1, 1,    1,    2,    1683, 1683, 1683,  1683, 1683, 1683, 0,     0,     0,     0,     0,    0,     0,     0,     0,     0,     0,     1680,  1680,  1680, 1680, 1680, 1680, 1680, 0,    1,    0,    17131,17111,0,    0,    1,    17051,17051,0,    17052,17052,2,    1,    0,    1708, 1712, 1714, 0,    1716, 0,    1718, 0,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1, 1836, 0, 1837, 0, 18381, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    0,     0,    0,    0,     1530, 1530,  1530, 0,     1, 1,    1,    0,    1683, 1683, 1683,  1683, 1683, 1683, 1683,  1683,  0,     0,     0,    0,     0,     1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    2,    2,    2,    1,    1,    17051,17051,0,    17052,17052,0,    1,    0,    2,    2,    2,    2, 2, 0, 0, 0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    1835, 0,    0,    0, 0, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1538,  0,    1530, 1530,  1530, 0,     0,    0,     1, 1,    1,    0,    1683, 1683, 1683,  1683, 1683, 1683, 1683,  1683,  0,     0,     0,    0,     0,     1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    2,    1711, 1711, 0,    1,    1,    17051,17051,0,    17052,17052,0,    1,    0,    2,    1,    1704, 1706, 2, 1, 1,    1,    2,    0,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 0,    1846, 1,    1,    1,    1833, 1833, 1833, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1536,  0,    1530, 1530,  1530, 0,     0,    0,     0, 0,    0,    0,    1683, 1683, 1683,  1683, 1683, 1683, 1683,  1683,  0,     0,     0,    0,     0,     1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    0,    1711, 1711, 2,    1,    1,    17051,17051,0,    0,    0,    0,    1,    0,    1702, 0,    17001,2,    2, 0, 0,    0,    2,    0,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 0,    1846, 1,    1832, 2,    1833, 1833, 1833, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1534,  0,    1530, 1530,  1530, 0,     0,    0,     0, 0,    0,    0,    1683, 1683, 1683,  1683, 1683, 1683, 1683,  1683,  0,     0,     0,    0,     0,     1680,  1680,  1680,  1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    2,    1703, 1703, 1703, 0,    1,    0,    0,    0,    0,    1,    1,    1,    0,    0,    0,    2,    2,    1, 0, 1630, 1630, 1630, 0,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 0,    0,    1,    0,    0,    1833, 1833, 1833, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1532,  0,    1530, 1530,  1530, 1530,  1530, 0,     0, 0,    0,    0,    1683, 1683, 1683,  1683, 1683, 1683, 0,     0,     0,     0,     0,    0,     0,     0,     0,     1680,  1680,  1680,  1680,  1680, 1680, 0, 1, 0,    1703, 0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    1700, 1700, 1700, 0,    1,    0,    1630, 1630, 1630, 0,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 1626, 0,    0,    1,    0,    0,    1833, 1833, 1833, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 1,    1,     2,    1,    1,     1530, 1530,  1530, 0,     0, 0,    0,    2,    1683, 1683, 1683,  1683, 1683, 1683, 0,     1682,  1682,  1682,  0,    16811, 0,     1681,  1681,  0,     1680,  1680,  1680,  1680, 1680, 1680, 0,    1,    1,    0,    1,    1,    1,    0,    1701, 0,    0,    0,    0,    1,    1,    0,    1700, 1700, 1700, 0,    1, 0, 1630, 1630, 1630, 0,    2,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 2,    2,    1,    1831, 0,    1833, 1833, 1833, 0, 1838, 1838, 1838, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      2, 2,    0,     0,    0,    0,     2,    0,     0,    0,     0, 0,    2,    0,    0,    0,    0,     0,    0,    1,    0,     2,     0,     0,     0,    2,     0,     0,     2,     0,     1,     0,     0,     0,    0,    0,    0,    2,    1,    1,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,    2,    0,    0,    0,    0,    0,    2,    1626, 1626, 1626, 1626, 1626, 1626, 1626, 1,    0,    2,    0,    0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     2,    2,      1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     1, 1,    1,    1,    1,    1,    1,     1,    1,    1,    1,     1,     1,     1,     1,    1,     1,     1,     1,     1,     1,     1,     1,     1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,    0,    2,    0,    0,    0,    2,    0,    2,    0,    1,    0,    0, 1830, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     2,    2,      1, 1,    1,     1,    0,    2,     0,    0,     0,    2,     0, 0,    0,    0,    0,    0,    1,     0,    0,    1,    1,     1,     1,     1,     0,    0,     0,     0,     0,     2,     0,     0,     0,     0,    0,    0,    0,    1,    1,    2,    1,    2,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    1,    1,    2,    1,    1,    1,    1,    1,    2,    1,    1,    0,    1625, 2,    1,    1,    2,    0,    1,    0,    1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      2, 0,    0,     2,    0,    1514,  1514, 1514,  1514, 1514,  0, 1419, 1419, 1419, 1419, 1419, 1419,  1419, 0,    1,    1,     1,     2,     0,     0,    16327, 2,     1632,  1632,  1632,  2,     0,     16321, 0,    1317, 1316, 0,    1,    0,    3,    0,    1313, 1313, 0,    1219, 1219, 1219, 1219, 1219, 1,    1,    1,    2,    1,    1,    1,    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,    0,    0,    1,    0,    1,    2,    1,    0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     1517,  1521, 1523,   1, 1512, 0,     3,    0,    1514,  1514, 1514,  1514, 1514,  0, 1419, 1419, 1419, 1419, 1419, 1419,  1419, 0,    1,    0,     0,     3,     0,     0,    16327, 0,     0,     0,     1,     0,     0,     0,     0,    1315, 1315, 0,    1,    0,    3,    0,    1313, 1313, 0,    1219, 1219, 1219, 1219, 1219, 1217, 1216, 0,    1,    1,    0,    2,    0,    3,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0, 16151, 1615, 0, 0, 0, 1614, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     1515,  2,    2,      1, 0,    0,     3,    0,    1514,  1514, 1514,  1514, 1514,  0, 1419, 1419, 1419, 1419, 1419, 1419,  1419, 0,    1,    0,     3,     3,     0,     0,    16327, 0,     16326, 2,     1,     16322, 0,     0,     0,    1315, 1315, 2,    1,    1312, 0,    0,    1313, 1313, 0,    1219, 1219, 1219, 1219, 1219, 0,    1215, 0,    1,    0,    0,    3,    0,    3,    3,    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0, 0, 1615, 0, 0, 1613, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     1513, 1511,   1, 0,    0,     0,    0,    2,     0,    0,     2,    0,     0, 0,    0,    0,    1419, 1419, 1419,  1419, 0,    1,    1414,  0,     0,     0,     0,    0,     0,     0,     0,     1,     1,     2,     0,     0,    0,    1315, 0,    1,    1311, 1309, 1325, 0,    1313, 0,    1219, 1219, 1219, 1219, 1219, 1,    12161,0,    1,    1214, 0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,    0,    2,    2, 0, 2, 0, 0, 0, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1507,  15072, 15071, 0,    1509,   1, 0,    15101, 1510, 2,    1508,  1508, 0,     1506, 15061, 0, 1419, 1419, 1419, 1419, 1419, 1419,  0,    0,    1,    1413,  1412,  1433,  0,     0,    16325, 16328, 16325, 16325, 2,     0,     16323, 0,     0,    1318, 1315, 0,    1,    1,    1,    1,    0,    1313, 0,    1219, 1219, 1219, 1219, 1219, 2,    0,    0,    1,    1213, 1212, 1229, 0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,    1,    2, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 2, 1, 2, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1507,  1507,  1507,  2,    0,      1, 0,    1510,  1510, 0,    15081, 1508, 1,     1506, 0,     0, 1419, 1419, 1419, 1419, 1419, 1419,  0,    0,    1,    1410,  1411,  1432,  0,     0,    16325, 16325, 16325, 0,     16324, 0,     16323, 0,     0,    1318, 1315, 2,    1,    1308, 1310, 1324, 0,    1313, 0,    1219, 1219, 1219, 1219, 0,    1218, 1218, 0,    1,    1210, 1211, 1228, 0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,    0, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     1,    1,      1, 0,    0,     2,    0,    0,     2,    0,     2,    0,     0, 2,    0,    0,    0,    0,    1418,  0,    0,    1,    2,     1409,  0,     0,     0,    2,     0,     16325, 0,     16324, 0,     2,     0,     0,    0,    0,    0,    1,    0,    0,    0,    0,    2,    2,    1219, 1219, 1219, 1219, 0,    2,    0,    0,    1,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,    0,    1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 1820, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1505,  1505,  0,     1,    1,      1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     0, 1,    1,    1,    1,    0,    0,     1430, 0,    1,    2,     1406,  1408,  0,     0,    1,     2,     16325, 0,     16324, 2,     1,     1,     0,    1323, 1323, 0,    1,    2,    1307, 1307, 0,    1,    0,    1219, 1219, 1219, 1219, 0,    1217, 1217, 0,    1,    1209, 0,    2,    1208, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,    0,    1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1505,  1505,  2,     1,    1,      1, 1,    1,     1,    1,    1,     1,    1,     2,    0,     1, 0,    1,    1,    1,    0,    1430,  1430, 0,    1,    0,     0,     1407,  0,     0,    1,     1,     0,     0,     0,     0,     1,     1,     0,    1323, 1323, 0,    1,    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    2, 1206,    2,    1207, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,     1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 15052, 15051, 0,     1,    1,      1, 1,    1,     1,    1,    1,     1,    1,     0,    1,     1, 0,    1,    1,    1,    0,    0,     1430, 2,    1,    0,     14021, 0,     0,     0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    2,    13052,1306, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    2,    1,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,    0,    1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     1,    1,      1, 0,    0,     0,    0,    1,     1,    0,     1,    1,     0, 1,    1,    1,    1,    0,    1431,  2,    0,    1,    1402,  1402,  1402,  1402,  0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    0,    13051,1304, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    12052,2,    1204, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,     1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 1603, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 15032, 15031, 0,     1,    1,      1, 0,    1502,  1502, 0,    1,     0,    1,     1,    0,     1, 1,    1,    1,    1,    0,    1429,  1428, 0,    1,    1402,  1402,  1402,  1402,  0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    0,    13051,1304, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    12051,1,    1204, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    1,    0,     1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 1603, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1503,  1503,  2,     1,    1,      1, 0,    1502,  1502, 0,    2,     1,    1,     0,    1,     1, 1,    1,    1,    1,    0,    0,     1426, 0,    1,    0,     0,     0,     0,     0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    0,    1300, 0,    0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    1205, 1,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    2, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 0, 1603, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     1,    1,      1, 0,    1502,  1502, 0,    1,     1,    0,     1,    1,     1, 1,    1,    1,    1,    0,    14272, 1423, 0,    1,    14003, 14005, 14004, 14006, 0,    0,     1,     1,     1,     1,     1,     1,     1,     2,    1323, 1323, 0,    1,    0,    1300, 1303, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    1200, 2,    1203, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    2,    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 1501,  1501,  2,     1,    1,      1, 2,    1502,  1502, 2,    1,     0,    0,     0,    0,     0, 1,    1,    1,    1,    0,    14271, 1423, 2,    1,    1400,  1400,  2,     14001, 0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    0,    1300, 1302, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    1200, 2,    1202, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    1, 1, 1, 1, 1, 1, 1, 1, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 15012, 15011, 0,     1,    1,      1, 0,    2,     2,    0,    1,     1,    1,     1,    1,     0, 1,    1,    1,    1,    0,    1425,  1424, 0,    1,    14002, 14002, 0,     2,     0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    1323, 1323, 0,    1,    0,    1300, 1301, 0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    2,    2,    1201, 0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0, 1, 1, 2, 1610, 2, 16072, 0, 16071, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     1,    1,      1, 2,    1500,  1500, 0,    0,     0,    0,     0,    0,     0, 1,    1,    1,    1,    0,    0,     0,    0,    1,    0,     0,     0,     0,     0,    0,     1,     1,     1,     1,     1,     1,     1,     0,    0,    0,    0,    1,    0,    2,    0,    0,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    0,    2,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    3, 1608, 1609, 2, 0, 0, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 2,     2,     0,     1,    1,      1, 0,    1500,  1500, 0,    1149,  0,    11471, 0,    1147,  0, 1,    1,    1,    1,    1,    1,     2,    1,    1,    1,     2,     1,     1,     1,    1,     1,     1,     1,     1,     1,     1,     1,     1,    1,    1,    2,    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    2, 1, 3, 1605, 1605, 1, 0, 0, 0, 1604, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 2,     2,     0,     1,    1,      1, 0,    0,     0,    0,    1149,  0,    11471, 0,    1147,  0, 1,    1,    1,    1,    1,    1,     2,    1,    1,    1,     2,     1,     1,     1,    1,     1,     1,     1,     1,     1,     1,     1,     1,    1,    1,    2,    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2, 1, 3, 0, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     0,     0,    0,      1, 0,    1151,  1151, 0,    1149,  0,    11471, 0,    1147,  0, 0,    0,    0,    0,    0,    0,     0,    0, 0, 1, 0, 0,     0,     0,     0,     0,    0,     0,     0,     0,     0,     0,     0,     0,     0,    0,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,    0,    2,    0,    16082,1, 0, 0, 0, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     1155,  0,     0,    1524,   1, 0,    2,     0,    0,    2,     0,    2,     0,    2,     0, 1143, 1143, 1141, 0,    1139, 0,     0,    0, 1420, 1, 0,     1129,  0,     1127,  1127, 0,     1125,  0,     1123,  0,     1121, 1121,   0,     0,    1320, 0,    1, 0, 1115, 0,    1113, 1113, 1113, 0,    1111, 0,    1109, 1109, 1109, 0,    1220, 1,    0,    0,    1101, 0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    1,    1,    16001, 16001, 16001, 16001, 16001, 1, 0, 1602, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     1157,  1153,  0,    1525,   1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     2, 1145, 2,    2,    1,    1,    0,     0,    0, 1421, 1, 0,     1129,  0,     1127,  1127, 2,     1125,  2,     1123,  2,     1121, 1121,   0,     0,    1321, 0,    1, 0, 1115, 0,    1113, 1113, 1113, 2,    1111, 2,    1109, 1109, 1109, 0,    1221, 1,    0,    0,    1101, 0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    1,    1,    0, 0, 0, 0, 0, 1, 0, 1602, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     1159,  1,     0,    1526,   1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     0, 0,    0,    2,    0,    0,    0,     0,    0, 1422, 1, 0,     2,     0,     2,     2,    0,     0,     0,     2,     0,     2,     2,     0,     0,    1322, 0,    1, 0, 2,    0,    2,    0,    2,    0,    0,    0,    2,    0,    2,    0,    1222, 1,    0,    0,    2,    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    1,    1,    1,    1,    1,    1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 2,     1,     1,     1,    1,      1, 1,    1,     1,    1,    1,     1,    1,     1,    1,     2, 1,    1,    1,    1,    1,    1,     1,    1,    1,    1,     1,     1,     1,     1,    1,     1,     1,     1,     1,     1,     1,     1,     1,    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    1,    1600, 1600, 1600, 1600, 1600, 1600, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     2,     0,    0,      0, 2,    0,     2,    0,    2,     0,    0,     0,    2,     0, 2,    2,    0,    1,    1,    0,     0,    0, 0, 2, 0, 2,     0,     0,     2,     0,    2,     0,     2,     0,     2,     0,     0,     0,     0,    0,    2,    0,    2,    0,    0,    2,    0,    2,    0,    0,    2,    0,    2,    0,    0,    0,    0,    2,    0,    2,    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,    0,    0,    0,    1,    1,    1600, 1600, 1600, 1600, 1600, 1600, 1, 0, 1601, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     1144,  0,    0,      0, 1142, 0,     3,    0,    1140,  2,    11381, 2,    1138,  0, 1136, 1134, 0,    1130, 1130, 0,     1,    1,    1,    1,     2,     3,     0,     1124, 1124,  0,     1122,  0,     1120,  0,     1118,  1118,  0,    1,    1,    1,    1,    2,    3,    0,    1114, 1114, 0,    1112, 0,    1110, 1110, 0,    1108, 0,    1,    1,    1,    1,    2,    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    1, 1600, 1600, 1600, 1600, 1600, 1600, 1, 1, 1601, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     1144,  2,     11421, 2, 1142, 0,     3,    0,    1140,  0,    0,     0,    1138,  0, 0,    0,    0,    1130, 1130, 0,     1,    1,    1,    1,     0,     3,     0,     1124, 1124,  0,     1122,  0,     1120,  0,     1118,  1118,  0,    1,    1,    1,    1,    0,    3,    0,    1114, 1114, 2,    1112, 0,    1110, 1110, 2,    1108, 0,    1,    1,    1,    1,    0,    3,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    1,    1, 1600, 1600, 1600, 1600, 1600, 1600, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0,     0,     1144,  0,    0,      0, 1142, 0,     3,    0,    1140,  0,    0,     0,    1138,  0, 1132, 1132, 2,    1130, 1130, 0,     1,    1,    1,    1,     0,     3,     0,     1124, 1124,  2,     1122,  0,     1120,  2,     1118,  1118,  0,    1,    1,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,     0,    0,     0,    0,     0,    0, 16122,    0,     0,    0,     0,    0,     0,    0,    0,    0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
		};
	
	// need to hide because it is lagging (too large)

void bfs(){ // generate the number of shortest steps for every block
	node startpos = {sx, sy, sz, 0};
	q.push(startpos);
	while(!q.empty()){
		node hd = q.front();
		q.pop();
		for(int i = 0; i < 6; i++){
			int xx = sdx[i] + hd.x;
			int yy = sdy[i] + hd.y;
			int zz = sdz[i] + hd.z;
			int step = hd.step + int(isb[xx][yy][zz] != cur);
			if(xx < 1 || yy < 1 || zz < 1 || xx > n || yy > m || zz > l || isb[xx][yy][zz] == 0 || v[xx][yy][zz] != 0){
				continue;
			}
			v[xx][yy][zz] = step;
			node nowpos = {xx, yy, zz, step};
			q.push(nowpos);
		}
	}
}

void dfs(int x, int y, int z){ // trace the matrix and generate the shortest path
	if(isb[x][y][z] == cur || nowstp == 0){
		return;
	}
	if(x < 1 || y < 1 || z < 1 || x > n || y > m || z > l || v[x][y][z] != nowstp - 1 || v[x][y][z] == 0){
        return;
    }
	nowstp--;
	px.push(x);
	py.push(y);
	pz.push(z);
	path.push_back({x, y, z});
	didx++;
	for(int i = 0; i < 6; i++){
		dfs(sdx[i] + x, sdy[i] + y, sdz[i] + z);
	}
}

void out(){

	cout<<"Starting Your ISB Journey..."<<endl<<"Head out of the door.";
	ddpre.x = path[1].x - path[0].x;
	ddpre.y = path[1].y - path[0].y;
	ddpre.z = path[1].z - path[0].z;
	for(int i = 2; i < didx; i++){
		dir = 0; //left 1 right 2 up 3 down 4
		ddnow.x = path[i].x - path[i-1].x;
		ddnow.y = path[i].y - path[i-1].y;
		ddnow.z = path[i].z - path[i-1].z;
		if(ddnow.x == ddpre.x && ddnow.y == ddpre.y && ddnow.z == ddpre.z){
			strct++; 
			continue;
		}
		if(ddnow.z == ddpre.z){
			if(ddpre.x == 1 && ddnow.y == -1) dir = 1;
			else if(ddpre.x == -1 && ddnow.y == 1) dir = 1;
			else if(ddpre.y == 1 && ddnow.x == 1) dir = 1;
			else if(ddpre.y == -1 && ddnow.x == -1) dir = 1;
			else dir = 2;
		}
		else{
			if(ddnow.z == 1) dir = 3;
			if(ddnow.z == -1) dir = 4;
		}
		ddpre = ddnow;

		cout<<endl<<"Walk straight until you reach ";
		if(isb[path[i].x][path[i].y][path[i].z] == 1) cout<<"a crossway approximately "<<strct*3<<"m away.";
		else if(isb[path[i].x][path[i].y][path[i].z] == 0) cout<<"the wall.";
		else if(isb[path[i].x][path[i].y][path[i].z] == 2) cout<<"a door approximately "<<strct*3<<"m away.";
		else cout<<"room "<<isb[path[i].x][path[i].y][path[i].z]<<'.';
		cout<<endl<<"Turn "<<dirmap[dir];
		strct = -1;
	}
	cout<<endl<<"Congratulations, you arrived."<<endl<<"Please rate us 5 stars."<<endl;

}

void rundebug(){
	for(int k = 1; k <= l; k++){
		for(int i = 1; i <= n; i++){
			for(int j = 1; j <= m; j++){
				if(i == 1){
					if(j < 10) cout<<j<<"   ";
					else cout<<j<<"  ";
					continue;
				}
				if(v[i][j][k] < 10) cout<<v[i][j][k]<<"   ";
				else if(v[i][j][k] < 100) cout<<v[i][j][k]<<"  ";
				else if(v[i][j][k] < 1000) cout<<v[i][j][k]<<" ";
			}
			cout<<endl;
		} 
		cout<<endl;
	}
	cout<<endl<<"Every coordinate in the shortest path:"<<endl;
	cout<<sx<<' '<<sy<<' '<<sz<<endl;
	while(!px.empty()){
		cout<<px.top()<<' '<<py.top()<<' '<<pz.top()<<' '<<isb[px.top()][py.top()][pz.top()]<<endl;
		px.pop();
		py.pop();
		pz.pop();
	}
	cout<<endl<<v[fx][fy][fz]<<" blocks far."<<endl;
}

int main(void){ // main function

	//This part is just for testing, remove after gathering isb data
		// cin>>n>>m>>l;
		// for(int k = 1; k <= l; k++){
		// 	for(int i = 1; i <= n; i++){
		// 		for(int j = 1; j <= m; j++){
		// 			cin>>isb[i][j][k];
		// 		}
		// 	}
		// }
		// cin>>sx>>sy>>sz>>fx>>fy>>fz;

	cin>>cur>>des;
	for(int k = 1; k <= l; k++){
		for(int i = 1; i <= n; i++){
			for(int j = 1; j <= m; j++){
				if(isb[i][j][k] == cur) sx = i, sy = j, sz = k;
				if(isb[i][j][k] == des) fx = i, fy = j, fz = k;
			}
		}
	}
	// cout<<sx<<sy<<sz<<fx<<fy<<fz;

	bfs();
	nowstp = v[fx][fy][fz] + 1;
	dfs(fx, fy, fz);
	v[sx][sy][sz] = 0;

	// rundebug();

	out();
	
	return 0;
}


/* Data guide:
	0: wall
	1: pathway
	2: door
	3: stairs
	everything else are room numbers
*/
